IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[VSE_ArtemisEnabledView]'))
BEGIN
    DROP VIEW[dbo].VSE_ArtemisEnabledView
END
GO

CREATE VIEW [dbo].VSE_ArtemisEnabledView
AS
SELECT
    [EPOProductProperties].[AutoID],
    [EPOLeafNode].[NodeName] AS ServerName,    
    CASE WHEN rsOASArtemisEnabled.Value IN (0, 1, 2, 3, 4) THEN 'Enabled' ELSE 'Disabled' END AS OASArtemisEnabled
FROM
    [EPOLeafNode]
    INNER JOIN [EPOProductProperties] ON [EPOLeafNode].[AutoID] = [EPOProductProperties].[ParentID]
    LEFT JOIN [dbo].EPOProductSettings AS rsOASArtemisEnabled ON (EPOProductProperties.AutoID = rsOASArtemisEnabled.ParentID AND
   							   	                                  rsOASArtemisEnabled.SectionName = N'On-Access General' AND
							   	                                  rsOASArtemisEnabled.SettingName = 'dwHeuristicNetCheckSensitivity')
WHERE
    EPOProductProperties.ProductCode LIKE 'VIRUSCAN%'
GO