IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'[dbo].[VSE_ArtemisLevelView]'))
BEGIN
    DROP VIEW[dbo].VSE_ArtemisLevelView
END
GO

CREATE VIEW [dbo].VSE_ArtemisLevelView
AS
SELECT
    [EPOProductProperties].[AutoID],
    [EPOLeafNode].[NodeName] AS ServerName,    
    CASE WHEN rsOASArtemisLevel.value IS NOT NULL THEN rsOASArtemisLevel.value ELSE 'Unknown' END AS OASArtemisLevel,
    CASE WHEN rsEmailArtemisLevel.value IS NOT NULL THEN rsEmailArtemisLevel.value ELSE 'Unknown' END AS EmailArtemisLevel,
    CASE WHEN rsODSArtemisLevel.value IS NOT NULL THEN rsODSArtemisLevel.value ELSE 'Unknown' END AS ODSArtemisLevel
FROM
    [EPOLeafNode]
    INNER JOIN [EPOProductProperties] ON [EPOLeafNode].[AutoID] = [EPOProductProperties].[ParentID]
    LEFT JOIN [dbo].EPOProductSettings AS rsOASArtemisLevel ON (EPOProductProperties.AutoID = rsOASArtemisLevel.ParentID AND
							   	                                rsOASArtemisLevel.SectionName = N'On-Access General' AND
							   	                                rsOASArtemisLevel.SettingName = N'dwHeuristicNetCheckSensitivity')
	LEFT JOIN [dbo].EPOProductSettings AS rsEmailArtemisLevel ON (EPOProductProperties.AutoID = rsEmailArtemisLevel.ParentID AND
							   	                                rsEmailArtemisLevel.SectionName = N'Email General' AND
							   	                                rsEmailArtemisLevel.SettingName = N'dwHeuristicNetCheckSensitivity')							   	                                
	LEFT JOIN [dbo].EPOProductSettings AS rsODSArtemisLevel ON (EPOProductProperties.AutoID = rsODSArtemisLevel.ParentID AND
							   	                                rsODSArtemisLevel.SectionName = N'On-Demand General' AND
							   	                                rsODSArtemisLevel.SettingName = N'dwHeuristicNetCheckSensitivity')							   	                                
WHERE
    EPOProductProperties.ProductCode LIKE 'VIRUSCAN%'
GO